﻿Imports Infragistics.Win.UltraWinEditors
Imports System.ComponentModel

Public Class ctlRecurrenceWeekly
    Implements INotifyPropertyChanged

    Private mclsRecurrence As clsRecurrence
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Public Overrides Function GetPreferredSize(proposedSize As Size) As Size
        Return New Size(538, 166)
    End Function
    'Public Event UpdateUI()

    Public Property Recurrence() As clsRecurrence
        Get
            Return mclsRecurrence
        End Get
        Set(ByVal value As clsRecurrence)
            If Me.mclsRecurrence Is value Then
                Return
            End If

            If mclsRecurrence IsNot Nothing Then
                RemoveHandler Recurrence.PropertyChanged, AddressOf Recurrence_PropertyChanged
            End If

            mclsRecurrence = value
            Me.UpdateUI()

            If mclsRecurrence IsNot Nothing Then
                AddHandler Recurrence.PropertyChanged, AddressOf Recurrence_PropertyChanged
            End If
        End Set
    End Property

    Private Sub Recurrence_PropertyChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)
        Me.UpdateUI()

        Dim e2 As PropertyChangedEventArgs = New PropertyChangedEventArgs("Recurrence")
        RaiseEvent PropertyChanged(Me, e2)
    End Sub

    Private Sub UpdateUI()
        Try
            If Me.Recurrence Is Nothing Then
                ResetRecurrence()
            End If

            numWeeks.Value = Recurrence.Interval
            chkSunday.Checked = Recurrence.Sunday
            chkMonday.Checked = Recurrence.Monday
            chkTuesday.Checked = Recurrence.Tuesday
            chkWednesday.Checked = Recurrence.Wednesday
            chkThursday.Checked = Recurrence.Thursday
            chkFriday.Checked = Recurrence.Friday
            chkSaturday.Checked = Recurrence.Saturday
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub

    Private Sub ResetRecurrence()
        Try

            numWeeks.Value = 1
            chkSunday.Checked = False
            chkMonday.Checked = False
            chkTuesday.Checked = False
            chkWednesday.Checked = False
            chkThursday.Checked = False
            chkFriday.Checked = False
            chkSaturday.Checked = False
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub

    Private Sub numWeeks_EditorButtonClick(sender As Object, e As EditorButtonEventArgs) Handles numWeeks.EditorButtonClick
        Try
            Select Case e.Button.Key
                Case "AddValue"
                    If (numWeeks.Value + numWeeks.SpinIncrement) <= numWeeks.MaxValue Then
                        numWeeks.Value += numWeeks.SpinIncrement
                    End If

                Case "DecreaseValue"
                    If (numWeeks.Value - numWeeks.SpinIncrement) >= numWeeks.MinValue Then
                        numWeeks.Value -= numWeeks.SpinIncrement
                    End If
            End Select

            If numWeeks.Value = 1 Then
                numWeeks.ButtonsRight("AddValue").Enabled = True
                numWeeks.ButtonsRight("DecreaseValue").Enabled = False
            ElseIf numWeeks.Value = 99 Then
                numWeeks.ButtonsRight("AddValue").Enabled = False
                numWeeks.ButtonsRight("DecreaseValue").Enabled = True
            Else
                numWeeks.ButtonsRight("AddValue").Enabled = True
                numWeeks.ButtonsRight("DecreaseValue").Enabled = True
            End If
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub

    Private Sub numWeeks_ValueChanged(sender As Object, e As EventArgs) Handles numWeeks.ValueChanged
        Try
            If Recurrence Is Nothing Then Return

            Recurrence.Interval = numWeeks.Value
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub

    Private Sub chkWeekdays_CheckedChanged(sender As Object, e As EventArgs) Handles _
        chkSunday.CheckedChanged, chkMonday.CheckedChanged, chkTuesday.CheckedChanged,
        chkWednesday.CheckedChanged, chkThursday.CheckedChanged, chkFriday.CheckedChanged, chkSaturday.CheckedChanged

        Try
            If Recurrence Is Nothing Then Return

            Dim blnChecked As Boolean = CType(sender, UltraCheckEditor).Checked

            Select Case CType(sender, UltraCheckEditor).Name
                Case "chkSunday"
                    Recurrence.Sunday = blnChecked
                Case "chkMonday"
                    Recurrence.Monday = blnChecked
                Case "chkTuesday"
                    Recurrence.Tuesday = blnChecked
                Case "chkWednesday"
                    Recurrence.Wednesday = blnChecked
                Case "chkThursday"
                    Recurrence.Thursday = blnChecked
                Case "chkFriday"
                    Recurrence.Friday = blnChecked
                Case "chkSaturday"
                    Recurrence.Saturday = blnChecked
            End Select
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
End Class
